#pragma once

// sapienCtrl.h : Declaration of the CsapienCtrl ActiveX Control class.


// CsapienCtrl : See sapienCtrl.cpp for implementation.

class CsapienCtrl : public COleControl
{
	DECLARE_DYNCREATE(CsapienCtrl)

// Constructor
public:
	CsapienCtrl();

// Overrides
public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual DWORD GetControlFlags();

// Implementation
protected:
	~CsapienCtrl();

	DECLARE_OLECREATE_EX(CsapienCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CsapienCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CsapienCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CsapienCtrl)		// Type name and misc status

// Message maps
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	DECLARE_DISPATCH_MAP()

// Event maps
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:

private:
	HANDLE handle;
	unsigned char initialized;

protected:

public:
	// opens port (such as COM1) and initializes communication
	void open(LPCTSTR port);
	// close the IR tower port
	void close(void);
	// converts command of given name to hexcode
	int decode(LPCSTR sapien_cmd, int version);
	// sends the specified code through the IR tower
	void send(int code, int nowakeup);
};

